{	This file has been processed by The THINK Pascal Source Converter, v1.1.	}

{}
{Created: Monday, January 14, 1991 at 4:56 PM}
{    Files.p}
{    Pascal Interface to the Macintosh Libraries}
{}
{        Copyright Apple Computer, Inc.    1985-1990}
{        All rights reserved}
{}



{	RMS	4/3/91		Modified to exclude declarations already in the THINK Pascal built-in interfaces	}



unit Files;
interface
	uses
		Types, OSUtils;

	const

{ masks for SpecBits values }
		fsSBPartialName = 1;
		fsSBFullName = 2;
		fsSBFlAttrib = 4;
		fsSBFlFndrInfo = 8;
		fsSBFlLgLen = 32;
		fsSBFlPyLen = 64;
		fsSBFlRLgLen = 128;
		fsSBFlRPyLen = 256;
		fsSBFlCrDat = 512;
		fsSBFlMdDat = 1024;
		fsSBFlBkDat = 2048;
		fsSBFlXFndrInfo = 4096;
		fsSBFlParID = 8192;
		fsSBNegate = 16384;
		fsSBDrUsrWds = 8;
		fsSBDrNmFls = 16;
		fsSBDrCrDat = 512;
		fsSBDrMdDat = 1024;
		fsSBDrBkDat = 2048;
		fsSBDrFndrInfo = 4096;
		fsSBDrParID = 8192;

{ vMAttrib (GetVolParms) bit position constants }
		bLimitFCBs = 31;
		bLocalWList = 30;
		bNoMiniFndr = 29;
		bNoVNEdit = 28;
		bNoLclSync = 27;
		bTrshOffLine = 26;
		bNoSwitchTo = 25;
		bNoDeskItems = 20;
		bNoBootBlks = 19;
		bAccessCntl = 18;
		bNoSysDir = 17;
		bHasExtFSVol = 16;
		bHasOpenDeny = 15;
		bHasCopyFile = 14;
		bHasMoveRename = 13;
		bHasDesktopMgr = 12;
		bHasShortName = 11;
		bHasFolderLock = 10;
		bHasPersonalAccessPrivileges = 9;
		bHasUserGroupList = 8;
		bHasCatSearch = 7;
		bHasFileIDs = 6;
		bHasBTreeMgr = 5;
		bHasBlankAccessPrivileges = 4;

{ Desktop Database icon Constants }
		kLargeIcon = 1;
		kLarge4BitIcon = 2;
		kLarge8BitIcon = 3;
		kSmallIcon = 4;
		kSmall4BitIcon = 5;
		kSmall8BitIcon = 6;

		kLargeIconSize = 256;
		kLarge4BitIconSize = 512;
		kLarge8BitIconSize = 1024;
		kSmallIconSize = 64;
		kSmall4BitIconSize = 128;
		kSmall8BitIconSize = 256;

{ foreign privilege model identifiers }
		fsUnixPriv = 1;

{ Version Release Stage Codes }
		developStage = $20;
		alphaStage = $40;
		betaStage = $60;
		finalStage = $80;

{ Authentication Constants }
		kNoUserAuthentication = 1;
		kPassword = 2;
		kEncryptPassword = 3;
		kTwoWayEncryptPassword = 6;

	type
		FXInfo = record
				fdIconID: INTEGER;                      { Icon ID}
				fdUnused: array[1..3] of INTEGER;      {unused but reserved 6 bytes}
				fdScript: SignedByte;                   { Script flag and number }
				fdXFlags: SignedByte;
				fdComment: INTEGER;                     { Comment ID}
				fdPutAway: LONGINT;                     { Home Dir ID}
			end;

		DXInfo = record
				frScroll: Point;                        {scroll position}
				frOpenChain: LONGINT;                   {DirID chain of open folders}
				frScript: SignedByte;                   { Script flag and number }
				frXFlags: SignedByte;
				frComment: INTEGER;                     {comment}
				frPutAway: LONGINT;                     {DirID}
			end;

		GetVolParmsInfoBuffer = record
				vMVersion: INTEGER;                     {version number}
				vMAttrib: LONGINT;                      {bit vector of attributes (see vMAttrib constants)}
				vMLocalHand: Handle;                    {handle to private data}
				vMServerAdr: LONGINT;                   {AppleTalk server address or zero}
				vMVolumeGrade: LONGINT;                 {approx. speed rating or zero if unrated}
				vMForeignPrivID: INTEGER;               {foreign privilege model supported or zero if none}
			end;

		CInfoPBPtr = ^CInfoPBRec;
		CInfoPBRec = record
				qLink: QElemPtr;
				qType: INTEGER;
				ioTrap: INTEGER;
				ioCmdAddr: Ptr;
				ioCompletion: ProcPtr;
				ioResult: OSErr;
				ioNamePtr: StringPtr;
				ioVRefNum: INTEGER;
				ioFRefNum: INTEGER;
				ioFVersNum: SignedByte;
				filler1: SignedByte;
				ioFDirIndex: INTEGER;
				ioFlAttrib: SignedByte;
				filler2: SignedByte;
				case CInfoType of
					hFileInfo: (
							ioFlFndrInfo: FInfo;
							ioDirID: LONGINT;
							ioFlStBlk: INTEGER;
							ioFlLgLen: LONGINT;
							ioFlPyLen: LONGINT;
							ioFlRStBlk: INTEGER;
							ioFlRLgLen: LONGINT;
							ioFlRPyLen: LONGINT;
							ioFlCrDat: LONGINT;
							ioFlMdDat: LONGINT;
							ioFlBkDat: LONGINT;
							ioFlXFndrInfo: FXInfo;
							ioFlParID: LONGINT;
							ioFlClpSiz: LONGINT
					);
					dirInfo: (
							ioDrUsrWds: DInfo;
							ioDrDirID: LONGINT;
							ioDrNmFls: INTEGER;
							filler3: array[1..9] of INTEGER;
							ioDrCrDat: LONGINT;
							ioDrMdDat: LONGINT;
							ioDrBkDat: LONGINT;
							ioDrFndrInfo: DXInfo;
							ioDrParID: LONGINT
					);
			end;

		CatPositionRec = record
				initialize: LONGINT;
				priv: array[1..6] of INTEGER;
			end;

		FSSpecPtr = ^FSSpec;
		FSSpecHandle = ^FSSpecPtr;
		FSSpec = record
				vRefNum: INTEGER;
				parID: LONGINT;
				name: Str63;
			end;

		FSSpecArrayPtr = ^FSSpecArray;
		FSSpecArrayHandle = ^FSSpecArrayPtr;

		FSSpecArray = array[0..0] of FSSpec;


{    The following are structures to be filled out with the _GetVolMountInfo call}
{    and passed back into the _VolumeMount call for external file system mounts.}

		VolumeType = OSType;

	const
		AppleShareMediaType = 'afpm';               { the signature for AppleShare }

	type
		VolMountInfoPtr = ^VolMountInfoHeader;
		VolMountInfoHeader = record
				length: INTEGER;                        { length of location data (including self) }
				media: VolumeType;                      { type of media. Variable length data follows }
			end;

		AFPVolMountInfoPtr = ^AFPVolMountInfo;
		AFPVolMountInfo = record
				length: INTEGER;                        { length of location data (including self) }
				media: VolumeType;                      { type of media }
				flags: INTEGER;                         { bits for no messages, no reconnect }
				nbpInterval: SignedByte;                { NBP Interval parameter (IM2, p.322) }
				nbpCount: SignedByte;                   { NBP Interval parameter (IM2, p.322) }
				uamType: INTEGER;                       { User Authentication Method }
				zoneNameOffset: INTEGER;                { short positive offset from start of struct to Zone Name }
				serverNameOffset: INTEGER;              { offset to pascal Server Name string }
				volNameOffset: INTEGER;                 { offset to pascal Volume Name string }
				userNameOffset: INTEGER;                { offset to pascal User Name string }
				userPasswordOffset: INTEGER;            { offset to pascal User Password string }
				volPasswordOffset: INTEGER;             { offset to pascal Volume Password string }
				AFPData: packed array[1..144] of CHAR;	{ variable length data may follow }
			end;

		DTPBPtr = ^DTPBRec;
		DTPBRec = record
				qLink: QElemPtr;
				qType: INTEGER;
				ioTrap: INTEGER;
				ioCmdAddr: Ptr;
				ioCompletion: ProcPtr;
				ioResult: OSErr;
				ioNamePtr: StringPtr;
				ioVRefNum: INTEGER;
				ioDTRefNum: INTEGER;
				ioIndex: INTEGER;
				ioTagInfo: LONGINT;
				ioDTBuffer: Ptr;
				ioDTReqCount: LONGINT;
				ioDTActCount: LONGINT;
				filler1: SignedByte;
				ioIconType: SignedByte;
				filler2: INTEGER;
				ioDirID: LONGINT;
				ioFileCreator: OSType;
				ioFileType: OSType;
				ioFiller3: LONGINT;
				ioDTLgLen: LONGINT;
				ioDTPyLen: LONGINT;
				ioFiller4: array[1..14] of INTEGER;
				ioAPPLParID: LONGINT;
			end;

		HParmBlkPtr = ^HParamBlockRec;
		HParamBlockRec = record
				qLink: QElemPtr;
				qType: INTEGER;
				ioTrap: INTEGER;
				ioCmdAddr: Ptr;
				ioCompletion: ProcPtr;
				ioResult: OSErr;
				ioNamePtr: StringPtr;
				ioVRefNum: INTEGER;
				case ParamBlkType of
					IOParam: (
							ioRefNum: INTEGER;
							ioVersNum: SignedByte;
							ioPermssn: SignedByte;
							ioMisc: Ptr;
							ioBuffer: Ptr;
							ioReqCount: LONGINT;                {size of buffer area}
							ioActCount: LONGINT;                {length of vol parms data}
							ioPosMode: INTEGER;
							ioPosOffset: LONGINT
					);
					FileParam: (
							ioFRefNum: INTEGER;
							ioFVersNum: SignedByte;
							filler1: SignedByte;
							ioFDirIndex: INTEGER;
							ioFlAttrib: SignedByte;
							ioFlVersNum: SignedByte;
							ioFlFndrInfo: FInfo;
							ioDirID: LONGINT;
							ioFlStBlk: INTEGER;
							ioFlLgLen: LONGINT;
							ioFlPyLen: LONGINT;
							ioFlRStBlk: INTEGER;
							ioFlRLgLen: LONGINT;
							ioFlRPyLen: LONGINT;
							ioFlCrDat: LONGINT;
							ioFlMdDat: LONGINT
					);
					VolumeParam: (
							filler2: LONGINT;
							ioVolIndex: INTEGER;
							ioVCrDate: LONGINT;
							ioVLsMod: LONGINT;
							ioVAtrb: INTEGER;
							ioVNmFls: INTEGER;
							ioVBitMap: INTEGER;
							ioAllocPtr: INTEGER;
							ioVNmAlBlks: INTEGER;
							ioVAlBlkSiz: LONGINT;
							ioVClpSiz: LONGINT;
							ioAlBlSt: INTEGER;
							ioVNxtCNID: LONGINT;
							ioVFrBlk: INTEGER;
							ioVSigWord: INTEGER;
							ioVDrvInfo: INTEGER;
							ioVDRefNum: INTEGER;
							ioVFSID: INTEGER;
							ioVBkUp: LONGINT;
							ioVSeqNum: INTEGER;
							ioVWrCnt: LONGINT;
							ioVFilCnt: LONGINT;
							ioVDirCnt: LONGINT;
							ioVFndrInfo: array[1..8] of LONGINT
					);
					AccessParam: (
							filler3: INTEGER;
							ioDenyModes: INTEGER;               {access rights data}
							filler4: INTEGER;
							filler5: SignedByte;
							ioACUser: SignedByte;               {access rights for directory only}
							filler6: LONGINT;
							ioACOwnerID: LONGINT;               {owner ID}
							ioACGroupID: LONGINT;               {group ID}
							ioACAccess: LONGINT
					);               {access rights}
					ObjParam: (
							filler7: INTEGER;
							ioObjType: INTEGER;                 {function code}
							ioObjNamePtr: Ptr;                  {ptr to returned creator/group name}
							ioObjID: LONGINT
					);                  {creator/group ID}
					CopyParam: (
							ioDstVRefNum: INTEGER;             {destination vol identifier}
							filler8: INTEGER;
							ioNewName: Ptr;                     {ptr to destination pathname}
							ioCopyName: Ptr;                    {ptr to optional name}
							ioNewDirID: LONGINT
					);               {destination directory ID}
					WDParam: (
							filler9: INTEGER;
							ioWDIndex: INTEGER;
							ioWDProcID: LONGINT;
							ioWDVRefNum: INTEGER;
							filler10: INTEGER;
							filler11: LONGINT;
							filler12: LONGINT;
							filler13: LONGINT;
							ioWDDirID: LONGINT
					);
					FIDParam: (
							filler14: LONGINT;
							ioDestNamePtr: StringPtr;
							filler15: LONGINT;
							ioDestDirID: LONGINT;
							filler16: LONGINT;
							filler17: LONGINT;
							ioSrcDirID: LONGINT;
							filler18: INTEGER;
							ioFileID: LONGINT
					);
					CSParam: (
							ioMatchPtr: FSSpecArrayPtr;        {match array}
							ioReqMatchCount: LONGINT;           {maximum allowable matches}
							ioActMatchCount: LONGINT;           {actual match count}
							ioSearchBits: LONGINT;              {search criteria selector}
							ioSearchInfo1: CInfoPBPtr;          {search values and range lower bounds}
							ioSearchInfo2: CInfoPBPtr;          {search values and range upper bounds}
							ioSearchTime: LONGINT;              {length of time to run the search}
							ioCatPosition: CatPositionRec;      {current position in the catalog}
							ioOptBuffer: Ptr;                   {optional performance enhancement buffer}
							ioOptBufSize: LONGINT
					);             {length of buffer pointed to by ioOptBuffer}
					ForeignPrivParam: (
							filler21: LONGINT;
							filler22: LONGINT;
							ioForeignPrivBuffer: Ptr;
							ioForeignPrivReqCount: LONGINT;
							ioForeignPrivActCount: LONGINT;
							filler23: LONGINT;
							ioForeignPrivDirID: LONGINT;
							ioForeignPrivInfo1: LONGINT;
							ioForeignPrivInfo2: LONGINT;
							ioForeignPrivInfo3: LONGINT;
							ioForeignPrivInfo4: LONGINT
					);
			end;

{Numeric version part of 'vers' resource}
		NumVersion = packed record
				case INTEGER of
					0: (
							majorRev: SignedByte;              {1st part of version number in BCD}
							minorRev: 0..9;                     {2nd part is 1 nibble in BCD}
							bugFixRev: 0..9;                    {3rd part is 1 nibble in BCD}
							stage: SignedByte;                  {stage code: dev, alpha, beta, final}
							nonRelRev: SignedByte
					);             {revision level of non-released version}
					1: (
							version: LONGINT
					);                 {to use all 4 fields at one time}
			end;

{'vers' resource format}
		VersRecPtr = ^VersRec;
		VersRecHndl = ^VersRecPtr;
		VersRec = record
				numericVersion: NumVersion;             {encoded version number}
				countryCode: INTEGER;                   {country code from intl utilities}
				shortVersion: Str255;                   {version number string - worst case}
				reserved: Str255;                       {longMessage string packed after shortVersion}
			end;


	function PBOpen (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBOpenSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A000, $3E80;
	function PBOpenAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A400, $3E80;
	function PBClose (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBCloseSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A001, $3E80;
	function PBCloseAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A401, $3E80;
	function PBRead (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBReadSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A002, $3E80;
	function PBReadAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A402, $3E80;
	function PBWrite (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBWriteSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A003, $3E80;
	function PBWriteAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A403, $3E80;
	function PBGetVInfo (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBGetVInfoSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A007, $3E80;
	function PBGetVInfoAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A407, $3E80;
	function PBGetVol (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBGetVolSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A014, $3E80;
	function PBGetVolAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A414, $3E80;
	function PBSetVol (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBSetVolSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A015, $3E80;
	function PBSetVolAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A415, $3E80;
	function PBFlushVol (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBFlushVolSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A013, $3E80;
	function PBFlushVolAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A413, $3E80;
	function PBCreate (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBCreateSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A008, $3E80;
	function PBCreateAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A408, $3E80;
	function PBDelete (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBDeleteSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A009, $3E80;
	function PBDeleteAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A409, $3E80;
	function PBOpenDF (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBOpenDFSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $701A, $A060, $3E80;
	function PBOpenDFAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $701A, $A460, $3E80;
	function PBOpenRF (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBOpenRFSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A00A, $3E80;
	function PBOpenRFAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A40A, $3E80;
	function PBRename (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBRenameSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A00B, $3E80;
	function PBRenameAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A40B, $3E80;
	function PBGetFInfo (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBGetFInfoSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A00C, $3E80;
	function PBGetFInfoAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A40C, $3E80;
	function PBSetFInfo (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBSetFInfoSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A00D, $3E80;
	function PBSetFInfoAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A40D, $3E80;
	function PBSetFLock (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBSetFLockSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A041, $3E80;
	function PBSetFLockAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A441, $3E80;
	function PBRstFLock (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBRstFLockSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A042, $3E80;
	function PBRstFLockAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A442, $3E80;
	function PBSetFVers (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBSetFVersSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A043, $3E80;
	function PBSetFVersAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A443, $3E80;
	function PBAllocate (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBAllocateSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A010, $3E80;
	function PBAllocateAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A410, $3E80;
	function PBGetEOF (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBGetEOFSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A011, $3E80;
	function PBGetEOFAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A411, $3E80;
	function PBSetEOF (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBSetEOFSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A012, $3E80;
	function PBSetEOFAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A412, $3E80;
	function PBGetFPos (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBGetFPosSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A018, $3E80;
	function PBGetFPosAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A418, $3E80;
	function PBSetFPos (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBSetFPosSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A044, $3E80;
	function PBSetFPosAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A444, $3E80;
	function PBFlushFile (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBFlushFileSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A045, $3E80;
	function PBFlushFileAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A445, $3E80;
	function PBMountVol (paramBlock: ParmBlkPtr): OSErr;
	function PBUnmountVol (paramBlock: ParmBlkPtr): OSErr;
	function PBEject (paramBlock: ParmBlkPtr): OSErr;
	function PBOffLine (paramBlock: ParmBlkPtr): OSErr;
	function PBCatSearch (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBCatSearchSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7018, $A260, $3E80;
	function PBCatSearchAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7018, $A660, $3E80;
	procedure AddDrive (drvrRefNum: INTEGER; drvNum: INTEGER; qEl: DrvQElPtr);
	function FSOpen (fileName: Str255; vRefNum: INTEGER; var refNum: INTEGER): OSErr;
	function OpenDF (fileName: Str255; vRefNum: INTEGER; var refNum: INTEGER): OSErr;
	function FSClose (refNum: INTEGER): OSErr;
	function FSRead (refNum: INTEGER; var count: LONGINT; buffPtr: Ptr): OSErr;
	function FSWrite (refNum: INTEGER; var count: LONGINT; buffPtr: Ptr): OSErr;
	function GetVInfo (drvNum: INTEGER; volName: StringPtr; var vRefNum: INTEGER; var freeBytes: LONGINT): OSErr;
	function GetFInfo (fileName: Str255; vRefNum: INTEGER; var fndrInfo: FInfo): OSErr;
	function GetVol (volName: StringPtr; var vRefNum: INTEGER): OSErr;
	function SetVol (volName: StringPtr; vRefNum: INTEGER): OSErr;
	function UnmountVol (volName: StringPtr; vRefNum: INTEGER): OSErr;
	function Eject (volName: StringPtr; vRefNum: INTEGER): OSErr;
	function FlushVol (volName: StringPtr; vRefNum: INTEGER): OSErr;
	function Create (fileName: Str255; vRefNum: INTEGER; creator: OSType; fileType: OSType): OSErr;
	function FSDelete (fileName: Str255; vRefNum: INTEGER): OSErr;
	function OpenRF (fileName: Str255; vRefNum: INTEGER; var refNum: INTEGER): OSErr;
	function Rename (oldName: Str255; vRefNum: INTEGER; newName: Str255): OSErr;
	function SetFInfo (fileName: Str255; vRefNum: INTEGER; fndrInfo: FInfo): OSErr;
	function SetFLock (fileName: Str255; vRefNum: INTEGER): OSErr;
	function RstFLock (fileName: Str255; vRefNum: INTEGER): OSErr;
	function Allocate (refNum: INTEGER; var count: LONGINT): OSErr;
	function GetEOF (refNum: INTEGER; var logEOF: LONGINT): OSErr;
	function SetEOF (refNum: INTEGER; logEOF: LONGINT): OSErr;
	function GetFPos (refNum: INTEGER; var filePos: LONGINT): OSErr;
	function SetFPos (refNum: INTEGER; posMode: INTEGER; posOff: LONGINT): OSErr;
	function GetVRefNum (fileRefNum: INTEGER; var vRefNum: INTEGER): OSErr;
	function PBOpenWD (paramBlock: WDPBPtr; async: BOOLEAN): OSErr;
	function PBOpenWDSync (paramBlock: WDPBPtr): OSErr;
	inline
		$205F, $7001, $A260, $3E80;
	function PBOpenWDAsync (paramBlock: WDPBPtr): OSErr;
	inline
		$205F, $7001, $A660, $3E80;
	function PBCloseWD (paramBlock: WDPBPtr; async: BOOLEAN): OSErr;
	function PBCloseWDSync (paramBlock: WDPBPtr): OSErr;
	inline
		$205F, $7002, $A260, $3E80;
	function PBCloseWDAsync (paramBlock: WDPBPtr): OSErr;
	inline
		$205F, $7002, $A660, $3E80;
	function PBHSetVol (paramBlock: WDPBPtr; async: BOOLEAN): OSErr;
	function PBHSetVolSync (paramBlock: WDPBPtr): OSErr;
	inline
		$205F, $A215, $3E80;
	function PBHSetVolAsync (paramBlock: WDPBPtr): OSErr;
	inline
		$205F, $A615, $3E80;
	function PBHGetVol (paramBlock: WDPBPtr; async: BOOLEAN): OSErr;
	function PBHGetVolSync (paramBlock: WDPBPtr): OSErr;
	inline
		$205F, $A214, $3E80;
	function PBHGetVolAsync (paramBlock: WDPBPtr): OSErr;
	inline
		$205F, $A614, $3E80;
	function PBCatMove (paramBlock: CMovePBPtr; async: BOOLEAN): OSErr;
	function PBCatMoveSync (paramBlock: CMovePBPtr): OSErr;
	inline
		$205F, $7005, $A260, $3E80;
	function PBCatMoveAsync (paramBlock: CMovePBPtr): OSErr;
	inline
		$205F, $7005, $A660, $3E80;
	function PBDirCreate (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBDirCreateSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7006, $A260, $3E80;
	function PBDirCreateAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7006, $A660, $3E80;
	function PBGetWDInfo (paramBlock: WDPBPtr; async: BOOLEAN): OSErr;
	function PBGetWDInfoSync (paramBlock: WDPBPtr): OSErr;
	inline
		$205F, $7007, $A260, $3E80;
	function PBGetWDInfoAsync (paramBlock: WDPBPtr): OSErr;
	inline
		$205F, $7007, $A660, $3E80;
	function PBGetFCBInfo (paramBlock: FCBPBPtr; async: BOOLEAN): OSErr;
	function PBGetFCBInfoSync (paramBlock: FCBPBPtr): OSErr;
	inline
		$205F, $7008, $A260, $3E80;
	function PBGetFCBInfoAsync (paramBlock: FCBPBPtr): OSErr;
	inline
		$205F, $7008, $A660, $3E80;
	function PBGetCatInfo (paramBlock: CInfoPBPtr; async: BOOLEAN): OSErr;
	function PBGetCatInfoSync (paramBlock: CInfoPBPtr): OSErr;
	inline
		$205F, $7009, $A260, $3E80;
	function PBGetCatInfoAsync (paramBlock: CInfoPBPtr): OSErr;
	inline
		$205F, $7009, $A660, $3E80;
	function PBSetCatInfo (paramBlock: CInfoPBPtr; async: BOOLEAN): OSErr;
	function PBSetCatInfoSync (paramBlock: CInfoPBPtr): OSErr;
	inline
		$205F, $700A, $A260, $3E80;
	function PBSetCatInfoAsync (paramBlock: CInfoPBPtr): OSErr;
	inline
		$205F, $700A, $A660, $3E80;
	function PBAllocContig (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBAllocContigSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A210, $3E80;
	function PBAllocContigAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $A610, $3E80;
	function PBLockRange (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBLockRangeSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $7010, $A260, $3E80;
	function PBLockRangeAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $7010, $A660, $3E80;
	function PBUnlockRange (paramBlock: ParmBlkPtr; async: BOOLEAN): OSErr;
	function PBUnlockRangeSync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $7011, $A260, $3E80;
	function PBUnlockRangeAsync (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $7011, $A660, $3E80;
	function PBSetVInfo (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBSetVInfoSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $700B, $A260, $3E80;
	function PBSetVInfoAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $700B, $A660, $3E80;
	function PBHGetVInfo (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHGetVInfoSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A207, $3E80;
	function PBHGetVInfoAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A607, $3E80;
	function PBHOpen (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHOpenSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A200, $3E80;
	function PBHOpenAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A600, $3E80;
	function PBHOpenRF (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHOpenRFSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A20A, $3E80;
	function PBHOpenRFAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A60A, $3E80;
	function PBHOpenDF (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHOpenDFSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $701A, $A260, $3E80;
	function PBHOpenDFAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $701A, $A660, $3E80;
	function PBHCreate (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHCreateSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A208, $3E80;
	function PBHCreateAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A608, $3E80;
	function PBHDelete (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHDeleteSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A209, $3E80;
	function PBHDeleteAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A609, $3E80;
	function PBHRename (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHRenameSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A20B, $3E80;
	function PBHRenameAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A60B, $3E80;
	function PBHRstFLock (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHRstFLockSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A242, $3E80;
	function PBHRstFLockAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A642, $3E80;
	function PBHSetFLock (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHSetFLockSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A241, $3E80;
	function PBHSetFLockAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A641, $3E80;
	function PBHGetFInfo (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHGetFInfoSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A20C, $3E80;
	function PBHGetFInfoAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A60C, $3E80;
	function PBHSetFInfo (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHSetFInfoSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A20D, $3E80;
	function PBHSetFInfoAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $A60D, $3E80;
	function PBMakeFSSpec (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBMakeFSSpecSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $701B, $A260, $3E80;
	function PBMakeFSSpecAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $701B, $A660, $3E80;
	procedure FInitQueue;
	inline
		$A016;
	function GetFSQHdr: QHdrPtr;
	inline
		$2EBC, $0000, $0360;
	function GetDrvQHdr: QHdrPtr;
	inline
		$2EBC, $0000, $0308;
	function GetVCBQHdr: QHdrPtr;
	inline
		$2EBC, $0000, $0356;
	function HGetVol (volName: StringPtr; var vRefNum: INTEGER; var dirID: LONGINT): OSErr;
	function HSetVol (volName: StringPtr; vRefNum: INTEGER; dirID: LONGINT): OSErr;
	function HOpen (vRefNum: INTEGER; dirID: LONGINT; fileName: Str255; permission: SignedByte; var refNum: INTEGER): OSErr;
	function HOpenDF (vRefNum: INTEGER; dirID: LONGINT; fileName: Str255; permission: SignedByte; var refNum: INTEGER): OSErr;
	function HOpenRF (vRefNum: INTEGER; dirID: LONGINT; fileName: Str255; permission: SignedByte; var refNum: INTEGER): OSErr;
	function AllocContig (refNum: INTEGER; var count: LONGINT): OSErr;
	function HCreate (vRefNum: INTEGER; dirID: LONGINT; fileName: Str255; creator: OSType; fileType: OSType): OSErr;
	function DirCreate (vRefNum: INTEGER; parentDirID: LONGINT; directoryName: Str255; var createdDirID: LONGINT): OSErr;
	function HDelete (vRefNum: INTEGER; dirID: LONGINT; fileName: Str255): OSErr;
	function HGetFInfo (vRefNum: INTEGER; dirID: LONGINT; fileName: Str255; var fndrInfo: FInfo): OSErr;
	function HSetFInfo (vRefNum: INTEGER; dirID: LONGINT; fileName: Str255; fndrInfo: FInfo): OSErr;
	function HSetFLock (vRefNum: INTEGER; dirID: LONGINT; fileName: Str255): OSErr;
	function HRstFLock (vRefNum: INTEGER; dirID: LONGINT; fileName: Str255): OSErr;
	function HRename (vRefNum: INTEGER; dirID: LONGINT; oldName: Str255; newName: Str255): OSErr;
	function CatMove (vRefNum: INTEGER; dirID: LONGINT; oldName: Str255; newDirID: LONGINT; newName: Str255): OSErr;
	function OpenWD (vRefNum: INTEGER; dirID: LONGINT; procID: LONGINT; var wdRefNum: INTEGER): OSErr;
	function CloseWD (wdRefNum: INTEGER): OSErr;
	function GetWDInfo (wdRefNum: INTEGER; var vRefNum: INTEGER; var dirID: LONGINT; var procID: LONGINT): OSErr;
	function PBHGetVolParms (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHGetVolParmsSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7030, $A260, $3E80;
	function PBHGetVolParmsAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7030, $A660, $3E80;
	function PBHGetLogInInfo (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHGetLogInInfoSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7031, $A260, $3E80;
	function PBHGetLogInInfoAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7031, $A660, $3E80;
	function PBHGetDirAccess (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHGetDirAccessSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7032, $A260, $3E80;
	function PBHGetDirAccessAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7032, $A660, $3E80;
	function PBHSetDirAccess (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHSetDirAccessSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7033, $A260, $3E80;
	function PBHSetDirAccessAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7033, $A660, $3E80;
	function PBHMapID (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHMapIDSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7034, $A260, $3E80;
	function PBHMapIDAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7034, $A660, $3E80;
	function PBHMapName (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHMapNameSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7035, $A260, $3E80;
	function PBHMapNameAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7035, $A660, $3E80;
	function PBHCopyFile (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHCopyFileSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7036, $A260, $3E80;
	function PBHCopyFileAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7036, $A660, $3E80;
	function PBHMoveRename (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHMoveRenameSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7037, $A260, $3E80;
	function PBHMoveRenameAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7037, $A660, $3E80;
	function PBHOpenDeny (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHOpenDenySync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7038, $A260, $3E80;
	function PBHOpenDenyAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7038, $A660, $3E80;
	function PBHOpenRFDeny (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBHOpenRFDenySync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7039, $A260, $3E80;
	function PBHOpenRFDenyAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7039, $A660, $3E80;
	function PBExchangeFiles (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBExchangeFilesSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7017, $A260, $3E80;
	function PBExchangeFilesAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7017, $A660, $3E80;
	function PBCreateFileIDRef (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBCreateFileIDRefSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7014, $A260, $3E80;
	function PBCreateFileIDRefAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7014, $A660, $3E80;
	function PBResolveFileIDRef (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBResolveFileIDRefSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7016, $A260, $3E80;
	function PBResolveFileIDRefAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7016, $A660, $3E80;
	function PBDeleteFileIDRef (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBDeleteFileIDRefSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7015, $A260, $3E80;
	function PBDeleteFileIDRefAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7015, $A660, $3E80;
	function PBGetForeignPrivs (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBGetForeignPrivsSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7060, $A260, $3E80;
	function PBGetForeignPrivsAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7060, $A660, $3E80;
	function PBSetForeignPrivs (paramBlock: HParmBlkPtr; async: BOOLEAN): OSErr;
	function PBSetForeignPrivsSync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7061, $A260, $3E80;
	function PBSetForeignPrivsAsync (paramBlock: HParmBlkPtr): OSErr;
	inline
		$205F, $7061, $A660, $3E80;

{  Desktop Manager  }
	function PBDTGetPath (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7020, $A260, $3E80;
	function PBDTCloseDown (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7021, $A260, $3E80;
	function PBDTAddIcon (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTAddIconSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7022, $A260, $3E80;
	function PBDTAddIconAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7022, $A660, $3E80;
	function PBDTGetIcon (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTGetIconSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7023, $A260, $3E80;
	function PBDTGetIconAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7023, $A660, $3E80;
	function PBDTGetIconInfo (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTGetIconInfoSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7024, $A260, $3E80;
	function PBDTGetIconInfoAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7024, $A660, $3E80;
	function PBDTAddAPPL (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTAddAPPLSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7025, $A260, $3E80;
	function PBDTAddAPPLAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7025, $A660, $3E80;
	function PBDTRemoveAPPL (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTRemoveAPPLSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7026, $A260, $3E80;
	function PBDTRemoveAPPLAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7026, $A660, $3E80;
	function PBDTGetAPPL (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTGetAPPLSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7027, $A260, $3E80;
	function PBDTGetAPPLAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7027, $A660, $3E80;
	function PBDTSetComment (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTSetCommentSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7028, $A260, $3E80;
	function PBDTSetCommentAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7028, $A660, $3E80;
	function PBDTRemoveComment (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTRemoveCommentSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7029, $A260, $3E80;
	function PBDTRemoveCommentAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $7029, $A660, $3E80;
	function PBDTGetComment (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTGetCommentSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $702A, $A260, $3E80;
	function PBDTGetCommentAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $702A, $A660, $3E80;
	function PBDTFlush (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTFlushSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $702B, $A260, $3E80;
	function PBDTFlushAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $702B, $A660, $3E80;
	function PBDTReset (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTResetSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $702C, $A260, $3E80;
	function PBDTResetAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $702C, $A660, $3E80;
	function PBDTGetInfo (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTGetInfoSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $702D, $A260, $3E80;
	function PBDTGetInfoAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $702D, $A660, $3E80;
	function PBDTOpenInform (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $702E, $A060, $3E80;
	function PBDTDelete (paramBlock: DTPBPtr; async: BOOLEAN): OSErr;
	function PBDTDeleteSync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $702F, $A060, $3E80;
	function PBDTDeleteAsync (paramBlock: DTPBPtr): OSErr;
	inline
		$205F, $702F, $A460, $3E80;
	function PBGetVolMountInfoSize (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $703F, $A260, $3E80;
	function PBGetVolMountInfo (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $7040, $A260, $3E80;
	function PBVolumeMount (paramBlock: ParmBlkPtr): OSErr;
	inline
		$205F, $7041, $A260, $3E80;

{  FSSpec Glue  }
	function FSMakeFSSpec (vRefNum: INTEGER; dirID: LONGINT; fileName: Str255; var spec: FSSpec): OSErr;
	inline
		$303C, $0001, $AA52;
	function FSpOpenDF (spec: FSSpec; permission: SignedByte; var refNum: INTEGER): OSErr;
	inline
		$303C, $0002, $AA52;
	function FSpOpenRF (spec: FSSpec; permission: SignedByte; var refNum: INTEGER): OSErr;
	inline
		$303C, $0003, $AA52;
	function FSpCreate (spec: FSSpec; creator: OSType; fileType: OSType; scriptTag: ScriptCode): OSErr;
	inline
		$303C, $0004, $AA52;
	function FSpDirCreate (spec: FSSpec; scriptTag: ScriptCode; var createdDirID: LONGINT): OSErr;
	inline
		$303C, $0005, $AA52;
	function FSpDelete (spec: FSSpec): OSErr;
	inline
		$303C, $0006, $AA52;
	function FSpGetFInfo (spec: FSSpec; var fndrInfo: FInfo): OSErr;
	inline
		$303C, $0007, $AA52;
	function FSpSetFInfo (spec: FSSpec; fndrInfo: FInfo): OSErr;
	inline
		$303C, $0008, $AA52;
	function FSpSetFLock (spec: FSSpec): OSErr;
	inline
		$303C, $0009, $AA52;
	function FSpRstFLock (spec: FSSpec): OSErr;
	inline
		$303C, $000A, $AA52;
	function FSpRename (spec: FSSpec; newName: Str255): OSErr;
	inline
		$303C, $000B, $AA52;
	function FSpCatMove (source: FSSpec; dest: FSSpec): OSErr;
	inline
		$303C, $000C, $AA52;
	function FSpExchangeFiles (source: FSSpec; dest: FSSpec): OSErr;
	inline
		$303C, $000F, $AA52;


    { UsingFiles }


implementation
end.

