{	This file has been processed by The THINK Pascal Source Converter, v1.1.	}

{}
{Created: Sunday, January 6, 1991 at 10:47 PM}
{    Memory.p}
{    Pascal Interface to the Macintosh Libraries}
{}
{        Copyright Apple Computer, Inc.    1985-1990}
{        All rights reserved}
{}


{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}


unit Memory;
interface
	uses
		Types;













	const
		maxSize = $800000;  {Max data block size is 8 megabytes}
		defaultPhysicalEntryCount = 8;
		defaultPhysicalEntryCountMinusOne = defaultPhysicalEntryCount - 1;

{ values returned from the GetPageState function }
		kPageInMemory = 0;
		kPageOnDisk = 1;
		kNotPaged = 2;

	type
		MemoryBlock = record
				address: Ptr;
				count: LONGINT;
			end;

		LogicalToPhysicalTable = record
				logical: MemoryBlock;
				physical: array[0..defaultPhysicalEntryCountMinusOne] of MemoryBlock;
			end;


		PageState = INTEGER;
		StatusRegisterContents = INTEGER;

	procedure HLockHi (h: Handle);
	inline
		$205F, $A064, $A029;
	function StripAddress (theAddress: univ Ptr): Ptr;

	function Translate24To32 (addr24: univ Ptr): Ptr;
	inline
		$201F, $A091, $2E80;
	function TempNewHandle (logicalSize: Size; var resultCode: OSErr): Handle;
	inline
		$3F3C, $001D, $A88F;
	function TempMaxMem (var grow: Size): Size;
	inline
		$3F3C, $0015, $A88F;
	function TempFreeMem: LONGINT;
	inline
		$3F3C, $0018, $A88F;

{  Temporary Memory routines renamed, but obsolete, in System 7.0 and later.  }
	procedure TempHLock (h: Handle; var resultCode: OSErr);
	inline
		$3F3C, $001E, $A88F;
	procedure TempHUnlock (h: Handle; var resultCode: OSErr);
	inline
		$3F3C, $001F, $A88F;
	procedure TempDisposeHandle (h: Handle; var resultCode: OSErr);
	inline
		$3F3C, $0020, $A88F;
	function TempTopMem: Ptr;
	inline
		$3F3C, $0016, $A88F;

{  Temporary Memory routines as they were known before System 7.0.  }
	function MFMaxMem (var grow: Size): Size;
	inline
		$3F3C, $0015, $A88F;
	function MFFreeMem: LONGINT;
	inline
		$3F3C, $0018, $A88F;
	function MFTempNewHandle (logicalSize: Size; var resultCode: OSErr): Handle;
	inline
		$3F3C, $001D, $A88F;
	procedure MFTempHLock (h: Handle; var resultCode: OSErr);
	inline
		$3F3C, $001E, $A88F;
	procedure MFTempHUnlock (h: Handle; var resultCode: OSErr);
	inline
		$3F3C, $001F, $A88F;
	procedure MFTempDisposHandle (h: Handle; var resultCode: OSErr);
	inline
		$3F3C, $0020, $A88F;
	function MFTopMem: Ptr;
	inline
		$3F3C, $0016, $A88F;

	function CompactMemSys (cbNeeded: Size): Size;

	procedure PurgeMemSys (cbNeeded: Size);
	inline
		$201F, $A44D;

	function FreeMemSys: LONGINT;
	inline
		$A41C, $2E80;
	procedure ResrvMem (cbNeeded: Size);
	inline
		$201F, $A040;
	procedure ReserveMem (cbNeeded: Size);
	inline
		$201F, $A040;
	procedure ReserveMemSys (cbNeeded: Size);
	inline
		$201F, $A440;

	function MaxMemSys (var grow: Size): Size;

	function HoldMemory (address: univ Ptr; count: LONGINT): OSErr;
	function UnholdMemory (address: univ Ptr; count: LONGINT): OSErr;
	function LockMemory (address: univ Ptr; count: LONGINT): OSErr;
	function LockMemoryContiguous (address: univ Ptr; count: LONGINT): OSErr;
	function UnlockMemory (address: univ Ptr; count: LONGINT): OSErr;
	function GetPhysical (var addresses: LogicalToPhysicalTable; var physicalEntryCount: LONGINT): OSErr;
	function DeferUserFn (userFunction: ProcPtr; argument: univ Ptr): OSErr;
	function DebuggerGetMax: LONGINT;
	inline
		$7000, $A08D, $2E80;
	procedure DebuggerEnter;
	inline
		$7001, $A08D;
	procedure DebuggerExit;
	inline
		$7002, $A08D;
	procedure DebuggerPoll;
	inline
		$7003, $A08D;
	function GetPageState (address: univ Ptr): PageState;
	inline
		$205F, $7004, $A08D, $3E80;
	function PageFaultFatal: BOOLEAN;
	inline
		$7005, $A08D, $1E80;
	function DebuggerLockMemory (address: univ Ptr; count: LONGINT): OSErr;
	function DebuggerUnlockMemory (address: univ Ptr; count: LONGINT): OSErr;
	function EnterSupervisorMode: StatusRegisterContents;
	inline
		$7008, $A08D, $3E80;


implementation
end.

